Index: /anuga_core/source/anuga/load_mesh/test_loadASCII.py
===================================================================
--- /anuga_core/source/anuga/load_mesh/test_loadASCII.py	(revision 5874)
+++ /anuga_core/source/anuga/load_mesh/test_loadASCII.py	(revision 5875)
@@ -10,5 +10,5 @@
 from os.path import splitext
 
-from Numeric import array, allclose 
+from Numeric import array, allclose, alltrue 
     
 from anuga.load_mesh.loadASCII import *
@@ -179,31 +179,31 @@
         #print "*(*("
         
-        self.failUnless(array(meshDict['vertices'])  ==
-                        array(loadedDict['vertices']),
+        self.failUnless(alltrue(array(meshDict['vertices'])  ==
+                        array(loadedDict['vertices'])),
                          'test_export_mesh_file failed. Test 1')
-        self.failUnless(array(meshDict['triangles'])  ==
-                        array(loadedDict['triangles']),
+        self.failUnless(alltrue(array(meshDict['triangles'])  ==
+                        array(loadedDict['triangles'])),
                          'test_export_mesh_file failed. Test 2')
-        self.failUnless(array(meshDict['segments'])  ==
-                        array(loadedDict['segments']),
+        self.failUnless(alltrue(array(meshDict['segments'])  ==
+                        array(loadedDict['segments'])),
                          'test_export_mesh_file failed. Test 3')
-        self.failUnless(array(meshDict['triangle_tags'])  ==
-                        array(loadedDict['triangle_tags']),
+        self.failUnless(alltrue(array(meshDict['triangle_tags'])  ==
+                        array(loadedDict['triangle_tags'])),
                          'test_export_mesh_file failed. Test 4')
-        
+
         self.failUnless(meshDict['vertex_attributes']  ==
                         loadedDict['vertex_attributes'],
                          'test_export_mesh_file failed. Test 5')
-        self.failUnless(array(meshDict['triangle_neighbors'])  ==
-                        array(loadedDict['triangle_neighbors']),
+        self.failUnless(alltrue(array(meshDict['triangle_neighbors'])  ==
+                        array(loadedDict['triangle_neighbors'])),
                          'test_export_mesh_file failed. Test 6')
-        self.failUnless(array(meshDict['segment_tags'])  ==
-                        array(loadedDict['segment_tags']),
+        self.failUnless(alltrue(array(meshDict['segment_tags'])  ==
+                        array(loadedDict['segment_tags'])),
                          'test_export_mesh_file failed. Test 7')
-        self.failUnless(array(meshDict['vertex_attribute_titles'])  ==
-                        array(loadedDict['vertex_attribute_titles']),
+        self.failUnless(alltrue(array(meshDict['vertex_attribute_titles'])  ==
+                        array(loadedDict['vertex_attribute_titles'])),
                          'test_export_mesh_file failed. Test 8')
-        self.failUnless(array(meshDict['geo_reference'])  ==
-                        array(loadedDict['geo_reference']),
+        self.failUnless(alltrue(array(meshDict['geo_reference'])  ==
+                        array(loadedDict['geo_reference'])),
                          'test_export_mesh_file failed. Test 9')
             
@@ -454,4 +454,5 @@
         assert allclose(array(loaded_dict['regions']),
                         array(dict['regions']))
+                        
         self.failUnless(loaded_dict['region_tags']  ==
                         dict['region_tags'],
@@ -474,5 +475,5 @@
         for ob, ldob in map(None,dict['triangle_tags'],
                               loaded_dict['triangle_tags']):
-            self.failUnless(ob  == ldob,
+            self.failUnless(ob == ldob,
                         fail_string + ' failed!! Test triangle_tags')
         # A bit hacky
@@ -494,6 +495,5 @@
                             array(loaded_dict['vertex_attribute_titles']))
         except TypeError:
-            self.failUnless(array(loaded_dict['vertex_attribute_titles'])  ==
-                        array(dict['vertex_attribute_titles']),
+            self.failUnless(alltrue(array(loaded_dict['vertex_attribute_titles']) == array(dict['vertex_attribute_titles'])),
                         fail_string + ' failed!! Test 8')
         try:    
Index: /anuga_core/source/anuga/mesh_engine/test_generate_mesh.py
===================================================================
--- /anuga_core/source/anuga/mesh_engine/test_generate_mesh.py	(revision 5874)
+++ /anuga_core/source/anuga/mesh_engine/test_generate_mesh.py	(revision 5875)
@@ -5,4 +5,11 @@
 level of the code, using the -j flag in triangle.
 """
+
+
+#FIXME (Ole): Go through this file and check that array's 
+#             aren't compared using ==. Need to use either alltrue 
+#             (on 1D integer arrays) or allclose.
+ 
+
 import sys
 
Index: /anuga_core/source/anuga/pmesh/test_mesh.py
===================================================================
--- /anuga_core/source/anuga/pmesh/test_mesh.py	(revision 5874)
+++ /anuga_core/source/anuga/pmesh/test_mesh.py	(revision 5875)
@@ -15,4 +15,6 @@
 from anuga.utilities.polygon import  is_inside_polygon ### inside_polygon
 
+from Numeric import alltrue, allclose
+
 class meshTestCase(unittest.TestCase):
     def setUp(self):
@@ -63,5 +65,5 @@
         self.failUnless(mesh.userSegments[0] == s3,
                         'Bad segment. ')        
-        self.failUnless(len(mesh.userSegments) ==1,
+        self.failUnless(len(mesh.userSegments) == 1,
                         'Segments not deleted.')
         self.failUnless(len(mesh.userVertices) == 2,
@@ -79,5 +81,5 @@
         s3 = Segment(a,f)
 
-        r1 = Region(0.3, 0.3,tag = 1.3,maxArea = .6)
+        r1 = Region(0.3, 0.3, tag = 1.3, maxArea = .6)
         #print r1
         m = Mesh(userVertices=[a,d,f], userSegments=[s1,s2,s3], regions=[r1] )
@@ -1656,10 +1658,10 @@
                          'test_Mesh2IOTriangulationDict failed. test 2')
 
-        self.failUnless( dict['vertices'] == verts,
+        self.failUnless( alltrue(dict['vertices'].flat == verts.flat),
                          'test_Mesh2IOTriangulationDict failed. test vert')
-        self.failUnless( dict['vertex_attributes'] == vert_as,
+        self.failUnless( alltrue(dict['vertex_attributes'].flat == vert_as.flat),
                          'test_Mesh2IOTriangulationDict failed. test vert ats')
 
-        self.failUnless( dict['segments'][0] == [0,1],
+        self.failUnless( alltrue(dict['segments'][0] == [0,1]),
                         'test_Mesh2IODict failed. test 3')
         
@@ -1667,7 +1669,7 @@
                         'test_Mesh2IODict failed. test 3')
         #print " dict['triangles'][0]", dict['triangles'][0] 
-        self.failUnless( dict['triangles'][0] == [3,2,4],
+        self.failUnless( alltrue(dict['triangles'][0] == [3,2,4]),
                         'test_Mesh2IODict failed. test 5')
-        self.failUnless( dict['triangle_neighbors'][0] == [-1,2,3],
+        self.failUnless( alltrue(dict['triangle_neighbors'][0] == [-1,2,3]),
                         'test_Mesh2IODict failed. test 6')
         #print "dict['triangle_tags'][0]", dict['triangle_tags'][0]
@@ -2178,6 +2180,7 @@
                         'FAILED!')
         vert= m.get_user_vertices(absolute=True)
-        self.failUnless(vert==points_ab,
-                        'FAILED!')
+        
+        self.failUnless(allclose(vert, points_ab),
+                        'FAILED!')        
 
     
@@ -2193,6 +2196,7 @@
         self.failUnless(4==len(vert),
                         'FAILED!')
-        vert= m.get_user_vertices(absolute=True)
-        self.failUnless(vert==points,
+        vert = m.get_user_vertices(absolute=True)
+        
+        self.failUnless(alltrue(vert.flat == array(points).flat),
                         'FAILED!')
     
@@ -2211,5 +2215,6 @@
                         'FAILED!')
         vert= m.get_user_vertices(absolute=True)
-        self.failUnless(vert==points_ab,
+        
+        self.failUnless(allclose(vert, points_ab),
                         'FAILED!')
 
@@ -2227,5 +2232,6 @@
                         'FAILED!')
         vert= m.get_user_vertices(absolute=True)
-        self.failUnless(vert==points_ab,
+        
+        self.failUnless(allclose(vert, points_ab),
                         'FAILED!')
 
@@ -2248,10 +2254,10 @@
                         'FAILED!')
         vert= m.get_user_vertices(absolute=True)
-        self.failUnless(vert==points_ab,
+        self.failUnless(allclose(vert, points_ab),
                         'FAILED!')
         vert= m.get_user_vertices(absolute=False)
         points_new = m.geo_reference.get_absolute(vert)
         
-        self.failUnless(points_ab==points_new,
+        self.failUnless(allclose(points_ab, points_new),
                         'FAILED!')
 