Index: /anuga_work/publications/boxing_day_validation_2008/patong_validation.tex
===================================================================
--- /anuga_work/publications/boxing_day_validation_2008/patong_validation.tex	(revision 5889)
+++ /anuga_work/publications/boxing_day_validation_2008/patong_validation.tex	(revision 5890)
@@ -23,5 +23,5 @@
 %------Abstract--------------
 \begin{abstract}
-Geoscience Australia, in an open collaboration with the Mathematical Sciences Institute, The Australian National University, is developing a software application, ANUGA, to model the hydrodynamics of tsunamis, floodsm and storm surges. The free source software implements a finite volume central-upwind Godunov method to solve the non-linear depth-averaged shallow water wave equations. This paper investigates the veracity of ANUGA  when used to model tsunami inundation.  A particular aim was to make use of the comparatively large amount of observed data corresponding to the Indian ocean tsunmai event of December 2004, to provide a conditional assessment of the computational model's performance. Specifically a comparison is made between a inundation map, constructed from observed data, against modelled maximum inundation. This comparison shows that there is very good agreement between the simulated and observed values. The sensitivity of model results to the resolution of bathymetry data used in the model was also investigated. It was found that the performance of the model could be drastically improved by using finer bathymetric data which better captures local topographic features. The effects of two different source models was explored.
+Geoscience Australia, in an open collaboration with the Mathematical Sciences Institute, The Australian National University, is developing a software application, ANUGA, to model the hydrodynamics of tsunamis, floods and storm surges. The open source software implements a finite volume central-upwind Godunov method to solve the non-linear depth-averaged shallow water wave equations. This paper investigates the veracity of ANUGA  when used to model tsunami inundation.  A particular aim was to make use of the comparatively large amount of observed data corresponding to the Indian ocean tsunmai event of December 2004, to provide a conditional assessment of the computational model's performance. Specifically a comparison is made between an inundation map, constructed from observed data, against modelled maximum inundation. This comparison shows that there is very good agreement between the simulated and observed values. The sensitivity of model results to the resolution of bathymetry data used in the model was also investigated. It was found that the performance of the model could be drastically improved by using finer bathymetric data which better captures local topographic features. The effects of two different source models was also explored.
 \end{abstract}
 %======================Section 1=================
@@ -30,7 +30,7 @@
 
 \section{Introduction}
-Tsunamis are a potential hazard to coastal communities all over the world. These `waves' can cause loss of life and have huge social and economic impacts. The so-called Indian Ocean tsunami killed around 230,000 people and caused billions of dollars in damage on the 26th of December 2004 (Synolakis {\it et al.} 2005). Hundreds of millions of dollars in aid has been donated to the rebuilding process and still the lives of hundreds of thousands of people will never be the same. Fortunately, catastrophic tsunamis of the scale of the 26 December 2004 event are exceedingly rare. However, smaller-scale tsunamis are more common and regularly threaten coastal communities around the world. Earthquakes that occur in the Java Trench near Indonesia (e.g. Tsuji {\it et al.} 1995) and along the Puysegur Ridge to the south of New Zealand (e.g. Lebrun {\it et al.} 1998) have potential to generate tsunamis that may threaten Australia's northwestern and southeastern coastlines.\nocite{synolakis05,tsuji95,lebrun98}
-
-For these reasons there has been increased focus on tsunami hazard mitigation over the past three years. Tsunami hazard mitigation involves detection, forecasting, and emergency preparedness (Synolakis {\it et al.} 2005). Unfortunately, due to the small time scales (at the most a few hours) over which tsunamis take to impact coastal communities, real time models that can be used for guidance as an event unfolds are currently underdeveloped. Consequently current tsunami mitigation efforts must focus on developing a database of pre-simulated scenarios to help increase effectiveness of immediate relief efforts. Firstly areas of high vulnerability, such as densely populated regions at risk of extreme damage, are identified. Action can then be undertaken before the event to minimise damage (early warning systems, breakwalls etc.) and protocols put in place to be followed when the flood waters subside. In this spirit, Titov {\it et al.} (2001)\nocite{titov01} discuss a current Short-term Inundation Forecasting (SIFT) project for tsunamis.
+Tsunamis are a potential hazard to coastal communities all over the world. These `waves' can cause loss of life and have huge social and economic impacts. The Indian Ocean tsunami killed around 230,000 people and caused billions of dollars in damage on the 26th of December 2004 (Synolakis {\it et al.} 2005). Hundreds of millions of dollars in aid has been donated to the rebuilding process and still the lives of hundreds of thousands of people will never be the same. Fortunately, catastrophic tsunamis of the scale of the 26 December 2004 event are exceedingly rare (Jankaew et al. 2008). However, smaller-scale tsunamis are more common and regularly threaten coastal communities around the world. Earthquakes that occur in the Java Trench near Indonesia (e.g. Tsuji {\it et al.} 1995) and along the Puysegur Ridge to the south of New Zealand (e.g. Lebrun {\it et al.} 1998) have potential to generate tsunamis that may threaten Australia's northwestern and southeastern coastlines.\nocite{synolakis05,tsuji95,lebrun98}
+
+For these reasons there has been an increased focus on tsunami hazard mitigation over the past three years. Tsunami hazard mitigation involves detection, forecasting, and emergency preparedness (Synolakis {\it et al.} 2005). Unfortunately, due to the small time scales (at the most a few hours) over which tsunamis take to impact coastal communities, real time models that can be used for guidance as an event unfolds are currently underdeveloped. Consequently current tsunami mitigation efforts must focus on developing a database of pre-simulated scenarios to help increase effectiveness of immediate relief efforts. Firstly areas of high vulnerability, such as densely populated regions at risk of extreme damage, are identified. Action can then be undertaken before the event to minimise damage (early warning systems, breakwalls etc.) and protocols put in place to be followed when the flood waters subside. In this spirit, Titov {\it et al.} (2001)\nocite{titov01} discuss a current Short-term Inundation Forecasting (SIFT) project for tsunamis.
 
 Several approaches are currently used to solve these problems. They differ in the way that the propagation of a tsunami is described. The shallow water wave equations, linearised shallow water wave equations, and Boussinesq-type equations are commonly accepted descriptions of flow. But the complex nature of these equations and the highly variable nature of the phenomena that they describe necessitate the use of numerical simulations.
@@ -50,5 +50,5 @@
 Although appalling, the devastation caused by the 2004 Indian Ocean tsunami has heightened community, scientific and governmental interest in tsunami and in doing so has provided a unique opportunity for further validation of tsunami models. Enormous resources have been spent to obtain many measurements of phenomenon pertaining to this event to better understand the destruction that occurred. Data sets from seismometers, tide gauges, GPS stations, a few satellite overpasses, subsequent coastal field surveys of run-up and flooding and measurements from ship-based expeditions, have now been made available (Vigny {\it et al.} 2005, Amnon {\it et al.} 2005, Kawata {\it et al.} 2005, and Liu {\it et al.} 2005)\nocite{vigny05,amnon05,kawata05,liu05}.
 
-An aim of this paper is to use this relative abundance of observed data corresponding to this event to further validate the use of ANUGA for modelling the inundation of tsunami.  The specific intention is to test the ability of the model to reprofuce an inundation survey of maximum runup constructed in the aftermath of the 2004 tsunami. A further aim is to test the sensitvity of the model predictions to bathymetry and tsunami source used.
+An aim of this paper is to use this relative abundance of observed data corresponding to this event to further validate the use of ANUGA for modelling the inundation of tsunami.  The specific intention is to test the ability of the model to reproduce an inundation survey of maximum runup constructed in the aftermath of the 2004 tsunami. A further aim is to test the sensitvity of the model predictions to bathymetry and tsunami source used.
 %=================Section=====================
 
@@ -67,5 +67,5 @@
 Here we note that the MOST model was developed as part of the Early Detection and Forecast of Tsunami (EDFT) project (Titov {\it et al.} 2005)\nocite{titov05}. MOST is a suite of integrated numerical codes capable of simulating tsunami generation, its propagation across, and its subsequent run-up. The exact nature of the MOST model is explained in (Titov and Synolakis 1995, Titov and Gonzalez 1997, Titov and Synolakis 1997, and Titov {\it et al.} 2005)\nocite{titov95,titov97a,titov97b,titov05}.
 
-ANUGA is an inundation tool that solves the depth integrated shallow water wave equations. The scheme used by ANUGA, first presented by Zoppou and Roberts (1999)\nocite{zoppou99}, is a high-resolution Godunov-type method that uses the rotational invariance property of the shallow water equations to transform the two-dimensional problem into local one-dimensional problems. These local Riemann problems are then solved using the semi-discrete central-upwind scheme of Kurganov {\it et al.} (2001) \nocite{kurganov01} for solving one-dimensional conservation equations. The numerical scheme is presented in detail in (Zoppou and Roberts 1999, Zoppou and Roberts 2000, and Roberts and Zoppou 2000, Nielsen {\it et al.} 2005) \nocite{zoppou99,zoppou00,roberts00,nielsen05}. An important capability of the software is that it can model the process of wetting and drying as water enters and leaves an area. This means that it is suitable for simulating water flow onto a beach or dry land and around structures such as buildings. It is also capable of resolving hydraulic jumps well due to the ability of the finite-volume method to handle discontinuities.
+ANUGA is an inundation tool that solves the depth integrated shallow water wave equations. The scheme used by ANUGA, first presented by Zoppou and Roberts (1999)\nocite{zoppou99}, is a high-resolution Godunov-type method that uses the rotational invariance property of the shallow water equations to transform the two-dimensional problem into local one-dimensional problems. These local Riemann problems are then solved using the semi-discrete central-upwind scheme of Kurganov {\it et al.} (2001) \nocite{kurganov01} for solving one-dimensional conservation equations. The numerical scheme is presented in detail in (Zoppou and Roberts 1999, Zoppou and Roberts 2000, and Roberts and Zoppou 2000, Nielsen {\it et al.} 2005) \nocite{zoppou99,zoppou00,roberts00,nielsen05}. An important capability of the software is that it can model the process of wetting and drying as water enters and leaves an area. This means that it is suitable for simulating water flow onto a beach or dry land and around structures such as buildings. It is also capable of adequately resolving hydraulic jumps due to the ability of the finite-volume method to handle discontinuities.
 
 
@@ -73,5 +73,7 @@
 The Indian Ocean tsunami of 2004 was generated by severe coseismic displacement of the sea floor as a result of one of the largest earthquakes on record. The M$_w$=9.2-9.3 mega-thrust earthquake occurred on the 26 December 2004 at 0h58'53'' UTC approximately 70 km offshore North Sumatra. The disturbance propagated 1200-1300 km along the Sumatra-Andaman trench time at a rate of 2.5-3 km.s$^{-1}$ and lasted approximately 8-10 minutes (Amnon {\it et al.} 2005)\nocite{amnon05}. At present ANUGA does not possess an explicit easy to use method for generating tsunamis from coseismic displacement, although such functionality could easily be added in the future. Implementing an explicit method for simulating coseismic displacement in ANUGA requires time for development and testing that could not be justified given the aims of the project and the time set aside for completion. Consequently in the following we employ the URS model and the MOST model to determine the sea floor deformation.
 
-Richard could you please add a description of the source model used for URS model. Any picture like the one below would be very useful. Or provide me with information, papers etc so that I can write this.
+The URS code uses a source model based on Wang (Wang et al. 2003) which is an elastic crustal model. The source parameters used to simulate the 2004 Indian Ocean Tsunami
+were taken from Chlieh (2007). The resulting sea floor displacement ranges from about - 5.0 to 5.0 metres and is shown in figure 3.
+
 
 The solution of Gusiakov (1972) \nocite{gusiakov72} is used by the MOST model to calculate the initial condition. This solution describes an earthquake consisting of two orthogonal shears with opposite sign. Specifically we adopt the parameterisation of Greensdale (2007) \nocite{greensdale07} who modelled the corresponding displacement by dividing the rupture zone into three fault segments with different morphologies and earthquake parameters. Details of the parameters associated with each of three regions used here are given in the same paper. The resulting sea floor displacement is shown in Figure \ref{fig:most_3_ruptures} and ranges between 3.6 m and 6.2 m.
@@ -79,6 +81,6 @@
 \begin{figure}[ht]
 \begin{center}
-\includegraphics[width=8.0cm,keepaspectratio=true]{most_3_ruptures.png}
-\caption{Location and magnitude of the sea floor displacement associated with the December 24 2004 tsunami. Taken from Greensdale {\it et al.} (2007)}
+\includegraphics[width=8.0cm,keepaspectratio=true]{chlieh_slip_model.png}
+\caption{Location and magnitude of the sea floor displacement associated with the December 24 2004 tsunami. Source parameters taken from Chlieh {\it et al.} (2007)}
 \label{fig:most_3_ruptures}
 \end{center}
@@ -89,5 +91,8 @@
 We use both the URS model and the MOST model to simulate the propagation of the 2004 Indian Ocean tsunami in the deep ocean ocean, based on a discrete representation of the initial deformation of the sea floor, described above. 
 
-Richard could you please add a brief description of URS model similar to the one given for most below. Or provide me with information, papers etc so that I can write this.
+The URS code models the propagation of the tsunami in deep water using the finite difference method to solve the non-linear shallow water equations in
+spherical co-ordinates with friction and coriolis terms. The code is based on Satake (1995) with significant modifications made by the URS corporation
+(Thio et al. 2007) and Geoscience Australia (Burbidge et al. 2007). The tsunami is propagated via a stagered grid system starting with coarser grids
+and ending with the finest one. The URS code is also capable of calculating inundation.
 
 Most models the propogation of the tsunami using a numerical dispersion scheme that solves the non-linear shallow-water wave equations in spherical coordinates, with Coriolis terms. This model has been extensively tested against a number of laboratory experiments and was successfully used for simulations of many historical tsunamis (Titov and Synolakis 1997, Titov and Gonzalez 1997, Bourgeois {\it et al.} 1999, and Yeh {\it et al.} 1994)\nocite{titov97a,titov97b,bourgeois99,yeh94}.
@@ -126,4 +131,6 @@
 
 Both the source models MOST and ... require the input of bathymetric data desribing the geometry of the sea floor. The data used ...
+
+The URS code employed 5 nested grids and their creation and data source are described below:
 	
 	DBDB2 2 minute of arc grid from the US Naval Research Labs.
@@ -200,4 +207,8 @@
 \bibitem{bourgeois99}
 Bourgeois, J., C. Petroff, H. Yeh, V. Titov, C. Synolakis, B. Benson, J. Kuroiwa, J. Lander, and E. Norabuena (1999), Geologic setting, field survey and modeling of the Chimbote, northern Peru, tsunami of 21 February 1996, {\em Pure and Applied Geophysics}, {\bf 154(3/4)}, pages 513-540.
+\bibitem{burbidge}
+Burbidge, D., P. Cummins, and R. Mleczko (2007), A Probabilistic Tsunami Hazard Assessment for Western Australia, Report to the Fire and Emergency Services Authority of Western Australia.
+\bibitem{chlieh}
+Chlieh, M., J. P. Avouac, et al. (2007). Coseismic slip and afterslip of the great Mw 9.15 Sumatra-Andaman earthquake of 2004. Bulletin of the Seismological Society of America, {\bf 97(1A) }, S152-S173.
 \bibitem{greensdale07}
 Greensdale, D., M . Simanjuntak, D. Burbidge, and J. Chittleborough (2007), A first-generation real-time tsunami forecasting system for the Australian region. BMRC Research Report 126, Bureau of Meteorology Australia.
@@ -206,4 +217,6 @@
 \bibitem{gusiakov72}
 Gusiakov, V.K. (1972), Static displacement on the surface of an elastic space. Ill-posed problems of mathematical physics and interpretation of geophysical data, {\em Novosibirsk, VC SOAN SSSR},  23-51. In Russian.
+\bibitem{jankaew}
+Jankaew, K., B. F. Atwater, et al. (2008). Medieval forewarning of the 2004 Indian Ocean tsunami in Thailand, Nature, {\bf 455(7217)}, 1228-1231.
 \bibitem{kawata05}
 Kawata, T. et XIV alia (2005) Comprehensive analysis of the damage and its impact on coastal zones by the 2004 Indian Ocean tsunami disaster. Technical report, Disaster Prevention Research Institute. http://www.tsunami.civil.tohoku.ac.jp/sumatra2004/\\report.html.
@@ -238,4 +251,6 @@
 \bibitem{titov01}
 Titov, V.V., F.I. Gonzalez, H.O. Mofjeld, and J.C. Newman (2001), Project SIFT (short-term inundation forecasting for tsunamis), In {\em ITS Proceedings}.
+\bibitem{gica08}
+Gica, E., M. Spillane, V.V. Titov, C.D. Chamberlin, and J.C. Newman (2008): Development of the forecast propagation database for NOAA's Short-term Inundation Forecast for Tsunamis (SIFT). NOAA Tech. Memo. {\bf OAR PMEL-139}, 89 pp.
 \bibitem{titov97b}
 Titov, V.V. and C.E. Synolakis (1997), Extreme inundation flows during the hokkaido Nansei-Oki tsunami, {\em Geophysical Research Letters}, {\bf 24(11)}, 1315-1318.