Index: /anuga_core/source_numpy_conversion/anuga/load_mesh/loadASCII.py
===================================================================
--- /anuga_core/source_numpy_conversion/anuga/load_mesh/loadASCII.py	(revision 5945)
+++ /anuga_core/source_numpy_conversion/anuga/load_mesh/loadASCII.py	(revision 5946)
@@ -60,4 +60,5 @@
 from os.path import splitext
 
+from anuga.config import Float, Character, Int
 from anuga.coordinate_transforms.geo_reference import Geo_reference,TITLE, TitleError
 
@@ -699,5 +700,5 @@
     if (mesh['vertices'].shape[0] > 0):
         outfile.createDimension('num_of_vertices', mesh['vertices'].shape[0])
-        outfile.createVariable('vertices', numpy.float, ('num_of_vertices',
+        outfile.createVariable('vertices', Float, ('num_of_vertices',
                                                    'num_of_dimensions'))
         outfile.variables['vertices'][:] = mesh['vertices']
@@ -709,9 +710,9 @@
                                     mesh['vertex_attribute_titles'].shape[1])
             outfile.createVariable('vertex_attributes',
-                                   numpy.float,
+                                   Float,
                                    ('num_of_vertices',
-                                    'num_of_vertex_attributes'))   
+                                    'num_of_vertex_attributes'))
             outfile.createVariable('vertex_attribute_titles',
-                                   numpy.character,
+                                   Character,
                                    ( 'num_of_vertex_attributes',
                                      'num_of_vertex_attribute_title_chars' ))
@@ -725,5 +726,5 @@
                                 mesh['segments'].shape[0])
         outfile.createVariable('segments',
-                               IntType,
+                               Int,
                                ('num_of_segments', 'num_of_segment_ends'))
         outfile.variables['segments'][:] = mesh['segments']
@@ -732,5 +733,5 @@
                                     mesh['segment_tags'].shape[1])
             outfile.createVariable('segment_tags',
-                                   numpy.character,
+                                   Character,
                                    ('num_of_segments',
                                     'num_of_segment_tag_chars'))
@@ -741,9 +742,9 @@
                                 mesh['triangles'].shape[0])
         outfile.createVariable('triangles',
-                               IntType,
+                               Int,
                                ('num_of_triangles',
                                 'num_of_triangle_vertices'))
         outfile.createVariable('triangle_neighbors',
-                               IntType,
+                               Int,
                                ('num_of_triangles',
                                 'num_of_triangle_faces'))
@@ -755,5 +756,5 @@
                                     mesh['triangle_tags'].shape[1]) 
             outfile.createVariable('triangle_tags',
-                                   numpy.character,
+                                   Character,
                                    ('num_of_triangles',
                                     'num_of_triangle_tag_chars'))
@@ -765,5 +766,5 @@
     if (mesh['points'].shape[0] > 0):
         outfile.createDimension('num_of_points', mesh['points'].shape[0])
-        outfile.createVariable('points', numpy.float, ('num_of_points',
+        outfile.createVariable('points', Float, ('num_of_points',
                                                  'num_of_dimensions'))
         outfile.variables['points'][:] = mesh['points'] 
@@ -772,5 +773,5 @@
                                     mesh['point_attributes'].shape[1])
             outfile.createVariable('point_attributes',
-                                   numpy.float,
+                                   Float,
                                    ('num_of_points',
                                     'num_of_point_attributes'))
@@ -781,5 +782,5 @@
                                 mesh['outline_segments'].shape[0])
         outfile.createVariable('outline_segments',
-                               IntType,
+                               Int,
                                ('num_of_outline_segments',
                                 'num_of_segment_ends'))
@@ -789,5 +790,5 @@
                                     mesh['outline_segment_tags'].shape[1])
             outfile.createVariable('outline_segment_tags',
-                                   numpy.character,
+                                   Character,
                                    ('num_of_outline_segments',
                                     'num_of_outline_segment_tag_chars'))
@@ -796,5 +797,5 @@
     if (mesh['holes'].shape[0] > 0):
         outfile.createDimension('num_of_holes', mesh['holes'].shape[0])
-        outfile.createVariable('holes', numpy.float, ('num_of_holes',
+        outfile.createVariable('holes', Float, ('num_of_holes',
                                                 'num_of_dimensions'))
         outfile.variables['holes'][:] = mesh['holes']
@@ -802,8 +803,8 @@
     if (mesh['regions'].shape[0] > 0):
         outfile.createDimension('num_of_regions', mesh['regions'].shape[0])
-        outfile.createVariable('regions', numpy.float, ('num_of_regions',
+        outfile.createVariable('regions', Float, ('num_of_regions',
                                                   'num_of_dimensions'))
         outfile.createVariable('region_max_areas',
-                               numpy.float,
+                               Float,
                                ('num_of_regions',))
         outfile.variables['regions'][:] = mesh['regions']
@@ -813,5 +814,5 @@
                                     mesh['region_tags'].shape[1])
             outfile.createVariable('region_tags',
-                                   numpy.character,
+                                   Character,
                                    ('num_of_regions',
                                     'num_of_region_tag_chars'))